{ $A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X+}
{$M 16384,0,655360}
{$I-,V-}
program PCLockInstall;

uses Dos, TpCrt, TpString, TpEdit;
const
  MBoot : array [0..511] of byte = (
  {$I PCLOCK_P.HEX}
  );

  hit = 'Sergdesign';

var
  o_93 : word absolute 0:$93*4;
  s_93 : word absolute 0:$93*4+2;
  r : registers;
  Clean, Esc : boolean;
  inName : PathStr;
  inf : file;
  a, Buf : array [1..10240] of byte;
{  b2 : array [1..10240] of char absolute Buf;}
  W : word;
  ch : char;
  i,j : word;
  Position,dpLen,SpLen : word;
  dp,Passw,p : string[10];

function Yes(s : string) : boolean;
var
  more : boolean;
begin
  Yes := FALSE;
  write(s, ' [Y/N] ? ');
  more := TRUE;
  while more do begin
    ch := upcase(ReadKey);
    if ch = #0 then ch := upcase(ReadKey);
    more := ( ch <> 'Y') and ( ch <> 'N' );
    if more then write(#7);
  end;
  writeln(ch);
  if ch = 'Y' then Yes := TRUE;
end;

procedure isp(func, sect, NumSect : byte; var a);
begin
  r.ah := func;
  r.dl := $80;
  r.dh := 0;
  r.ch := 0;
  r.cl := sect;
  r.al := NumSect;
  r.es := seg(a);
  r.bx := ofs(a);
  intr($93,r)
end;

procedure Directory(prompt : string; offset : byte);
var
  s : string;
begin
  Move(Buf[Position+161+12*offset], s[1], 12);
  for i := 1 to 12 do s[i] := chr( ord(s[i]) xor $1B );
  s[0] := #12;
  i := 1; while s[i] <> #0 do Inc(i); s[0] := chr(i-1);
  ReadString(prompt,WhereY,2,79,7,7,$70,Esc,s);
  writeln;
  s := PadCh(s, #0, 12);
  for i := 1 to 12 do s[i] := chr( ord(s[i]) xor $1B );
  Move(s[1], Buf[Position+161+12*offset], 12);
end;

begin
  if (mem[0:$4B0] = $81) and (mem[0:$4B1] = $FA) then begin
    o_93 := memw[0:$4BF];
    s_93 := memw[0:$4C1];
  end else begin
    r.ah := $13;
    intr($2F,r);
    o_93 := r.dx;
    s_93 := r.ds;
    intr($2F,r);
  end;

  isp(2, 1, 7, a);
  inName := 'PCLOCK.SYS';
  ForceUpper := True;
  TextColor(White);
  writeln('PC Lock Installation Program Version 1.7 (C) 1991 Sergdesign.');
  writeln;

  TextColor(LightGray);
  assign(inf, inName);
  reset(inf, 1);
  if IOResult <> 0 then begin
    writeln('ERROR : PCLOCK.SYS must be in the current path.');
    halt(1);
  end;

  BlockRead (inf, Buf, 10240, W);
  if W = 0 then begin
    writeln('error reading ''',inName,'''');
    close (inf); halt(1);
  end;
  close(inf);

  j := 22;
  move(Buf[105], Position, 2);
  Inc(Position);
  for i := 1 to 22 do begin
    Buf[Position + i - 1] := Buf[Position + i - 1] xor j;
    dec(j);
  end;
  move(Buf[Position + 11], Passw, 11);

  p := '';
  write(' Enter password : ');
  ch := ReadKey;
  while ch <> #13 do begin
    P := P + ch;
    ch := ReadKey;
  end;

  if p = Passw then writeln('Ok!') else halt(1);

  if (a[3] = $50) and (a[4] = $43) and (a[5] = $4C) then begin
   if Yes(' PC Lock partition already installed. Remove it') then begin
      isp(2, 11, 7, a); { read original partition }
      isp(3, 1, 7, a); { write original partition }
      FillChar(a, 512*7, #0);
      isp(3, 11, 7, a);
      writeln(' PC Lock partition removed.');
    end;
  end else begin
    if Yes(' Install PC Lock partition') then begin
      isp(2, 11, 1, a);
      Clean := TRUE;
      for i := 1 to 512 do if a[i] <> 0 then Clean := FALSE;
      if Clean then begin
        isp(2, 1, 7, a); { read original partition }
        isp(3, 11, 7, a); { write it }
        isp(3, 1, 1, MBoot);
        writeln(' PC Lock partition installed.');
      end else writeln(' PC Lock partition can''t be installed.');
    end;
  end;

  if Yes(' Change drive password') then begin
    write(' Enter drive password : ');
    dp := '';
    ch := ReadKey;
    while ch <> #13 do begin
      dp := dp + ch;
      ch := ReadKey;
    end;
    dpLen := Length(dp);
    writeln;
    dp := PadCh(dp, #0, 11);
    dp[0] := chr(dpLen);
    move(dp, Buf[Position], 11);
  end;

  if Yes(' Change SuperUser password') then begin
    write(' Enter SuperUser password : ');
    p := '';
    ch := ReadKey;
    while ch <> #13 do begin
      P := P + ch;
      ch := ReadKey;
    end;
    SpLen := Length(p);
    writeln;
    p := PadCh(p, #0, 11);
    p[0] := chr(SpLen);
    move(p, Buf[Position+11], 11);
  end;

  j := 22;
  for i := 1 to 22 do begin
    Buf[Position + i - 1] := Buf [Position + i - 1] xor j;
    dec(j);
  end;

  Directory('First directory : ', 4);
  Directory('Second directory : ', 5);
  Directory('Third directory : ', 6);

  rewrite(inf,1);
  BlockWrite (inf, Buf, W);
  close(inf);

  writeln;
  writeln('Installation complete.');
end.